<template>
  <b-field
    :type="{ 'is-danger': $v.name.$error }"
    :message="{
      'Name is required': $v.name.$error && !$v.name.required,
      'Name should have at least 3 characters': $v.name.$error && !$v.name.name
    }"
    label="Full name">
    <b-input
      v-model="$v.name.$model"
      size="is-medium"
    />
  </b-field>
</template>

<script>
import { requiredIf, minLength } from 'vuelidate/lib/validators'

export default {
  props: {
    value: {
      type: String,
      default: ''
    },
    required: {
      type: Boolean,
      default: false
    }
  },
  validations: {
    name: { required: requiredIf('isRequired'), minLength: minLength(3) }
  },
  computed: {
    name: {
      get () {
        return this.value
      },

      set (value) {
        this.$emit('input', value)
      }
    },
    isRequired () {
      return this.required
    }
  }
}
</script>
